Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 726)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 736)
@@ -332,7 +332,5 @@
 		InitVisibilityCulling(mCameraInProgress);
 
-		std::stringstream d; d << "here34\n";
-		LogManager::getSingleton().logMessage(d.str());
-
+	
 		/** 
 		* the hierarchical culling algorithm
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreSolidBoundingBox.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreSolidBoundingBox.cpp	(revision 722)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreSolidBoundingBox.cpp	(revision 736)
@@ -158,5 +158,4 @@
 Real SolidBoundingBox::getSquaredViewDepth(const Camera* cam) const
 {
-	Ogre::LogManager::getSingleton().logMessage("here3");
 	const Vector3 &min = mBox.getMinimum();
 	const Vector3 &max = mBox.getMaximum();
Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/egsr_test_script
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/egsr_test_script	(revision 711)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/egsr_test_script	(revision 736)
@@ -117,5 +117,5 @@
 -vsp_bsp_use_cost_heuristics=false \
 -vsp_bsp_max_poly_candidates=0 \
--vsp_bsp_breath_first_splits=true \
+-vsp_bsp_node_queue_type=0 \
 -vsp_bsp_term_min_pvs=50 \
 -view_cells_construction_samples=0 \
@@ -153,5 +153,5 @@
 -vsp_bsp_max_poly_candidates=0 \
 -vsp_bsp_use_split_cost_queue=false \
--vsp_bsp_breath_first_splits=true \
+-vsp_bsp_node_queue_type=0 \
 -view_cells_filename=$LOG_PREFIX-$METHOD-viewCells.x3d
 
@@ -181,5 +181,5 @@
 -vsp_bsp_use_cost_heuristics=false \
 -vsp_bsp_max_poly_candidates=0 \
--vsp_bsp_breath_first_splits=true \
+-vsp_bsp_node_queue_type=0 \
 -view_cells_construction_samples=0 \
 -vsp_bsp_simulate_octree=true \
Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/default.env
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/default.env	(revision 728)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/default.env	(revision 736)
@@ -378,5 +378,5 @@
 	useRandomAxis false
 	usePolygonSplitIfAvailable false
-	useBreathFirstSplits false
+	nodePriorityQueueType 0
 
 	Visualization {
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 734)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 736)
@@ -401,5 +401,5 @@
 
 
-int ViewCellsTree::GetSize(ViewCell *vc) const
+int ViewCellsTree::GetNumInitialViewCells(ViewCell *vc) const
 {
 	int vcSize = 0;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 735)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 736)
@@ -1234,5 +1234,4 @@
 					"5");
 
-
 	RegisterOption("ViewCells.renderCostEvaluationType",
 					optString,
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h	(revision 734)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h	(revision 736)
@@ -270,6 +270,5 @@
 	ViewCellLeaf<T>(): mLeaf(NULL) { SetActive(); }
 	ViewCellLeaf<T>(Mesh *mesh):
-		ViewCell(mesh), mLeaf(NULL) { SetActive(); }
-
+	ViewCell(mesh), mLeaf(NULL) { SetActive(); }
 	
 
@@ -299,5 +298,5 @@
 	/** Returns number of leaves this view cell consists of.
 	*/
-	int GetSize(ViewCell *vc) const;
+	int GetNumInitialViewCells(ViewCell *vc) const;
 
 	/** Collects leaves corresponding to a view cell.
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 735)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 736)
@@ -552,4 +552,6 @@
 	maxRenderCost = viewCells.back()->GetRenderCost();
 
+	Debug << "histogram minrc: " << minRenderCost << " maxrc: " << maxRenderCost << endl;
+
 	const int intervals = min(10000, (int)viewCells.size());
 
@@ -561,10 +563,10 @@
 	const float totalRenderCost = mViewCellsTree->GetRoot()->GetRenderCost();
 	const float totalVol = GetViewSpaceBox().GetVolume();
-
-	float vol = 0;
-	int smallerCost = 0;
+	//const float totalVol = mViewCellsTree->GetRoot()->GetVolume();
+
+	//float vol = 0;
+	//int smallerCost = 0;
+	int j = 0;
 	int i = 0;
-	int j = 0;
-
 	
 	ViewCellContainer::const_iterator it = viewCells.begin(), it_end = viewCells.end();		
@@ -574,4 +576,7 @@
     while (1)
 	{
+		float vol = 0;
+		int smallerCost = 0;
+
 		while ((i < (int)viewCells.size()) && (viewCells[i]->GetRenderCost() < currentRenderCost))
 		{
@@ -580,19 +585,23 @@
 			++ smallerCost;
 		}
-
-		if ((i >= (int)viewCells.size()) || (currentRenderCost >= maxRenderCost))
+		
+		if (i < (int)viewCells.size())
+			Debug << "new rc increase: " << viewCells[i]->GetRenderCost() / totalVol << " " << currentRenderCost / totalVol << endl;
+
+		if ((smallerCost >= (int)viewCells.size()) || (currentRenderCost >= maxRenderCost))
 			break;
-
+		
 		float rcRatio = currentRenderCost / maxRenderCost;
 		float volRatio = vol / totalVol;
 
-		outstream << "#Pass\n" << j ++ << endl;
-		outstream << "#RenderCost\n" << rcRatio << endl;
-		//fprintf(outstream, "#RenderCost\n%3.3f", rcRatio);
-		outstream << "#ViewCells\n" << i << endl;		
+		outstream << "#Pass\n" << j << endl;
+		outstream << "#RenderCostRatio\n" << rcRatio << endl;
+		outstream << "#WeightedCost\n" << currentRenderCost / totalVol << endl;
+		outstream << "#ViewCells\n" << smallerCost << endl;		
 		outstream << "#Volume\n" << volRatio << endl << endl;
 
 		// increase current render cost
 		currentRenderCost += stepSize;
+		++ j;
 	}
 
@@ -617,4 +626,6 @@
 	minPvsSize = viewCells.front()->GetPvs().GetSize();
 	maxPvsSize = viewCells.back()->GetPvs().GetSize();
+	
+	Debug << "histogram minpvssize: " << minPvsSize << " maxpvssize: " << maxPvsSize << endl;
 
 	const int intervals = min(10000, (int)viewCells.size());
@@ -629,22 +640,24 @@
 	int currentPvsSize = minPvsSize;//(int)ceil(minRenderCost);
 
-	float vol = 0;
-	int smallerCost = 0;
-
+	//float vol = 0;
 	int i = 0;
 	int j = 0;
 
-	
 	ViewCellContainer::const_iterator it = viewCells.begin(), it_end = viewCells.end();		
 	
-	// note can skip computations for view cells already evaluated and delete them from vector ...
-    while (1)
-	{
+	while (1)
+	{
+		float vol = 0;
+		int smaller = 0;
+
 		while ((i < (int)viewCells.size()) && (viewCells[i]->GetPvs().GetSize() < currentPvsSize))
 		{
 			vol += viewCells[i]->GetVolume();
 			++ i;
-			++ smallerCost;
-		}
+			++ smaller;
+		}
+		
+		if (i < (int)viewCells.size())
+			Debug << "new pvs size increase: " << viewCells[i]->GetPvs().GetSize() << " " << currentPvsSize << endl;
 
 		if ((i >= (int)viewCells.size()) || (currentPvsSize >= maxPvsSize))
@@ -655,6 +668,5 @@
 		outstream << "#Pass\n" << j ++ << endl;
 		outstream << "#Pvs\n" << currentPvsSize << endl;
-		//fprintf(outstream, "#RenderCost\n%3.3f", rcRatio);
-		outstream << "#ViewCells\n" << i << endl;		
+		outstream << "#ViewCells\n" << smaller << endl;		
 		outstream << "#Volume\n" << volRatio << endl << endl;
 
@@ -756,4 +768,9 @@
 	environment->GetIntValue("ViewCells.Evaluation.histoPasses", histoPasses);
 
+	int numLeaves = mViewCellsTree->GetNumInitialViewCells(mViewCellsTree->GetRoot());
+
+	Debug << "number of leaves: " << numLeaves << endl;
+	cout << "number of leaves: " << numLeaves << endl;
+
 	if (useHisto)
 	{
@@ -763,5 +780,5 @@
 		for (int passes = 1; passes <= histoPasses; ++ passes)
 		{
-			int n = (int)mViewCells.size() * passes / histoPasses;
+			int n = numLeaves * passes / histoPasses;
 		
 			cout << "computing histogram for " << n << " view cells" << endl;
@@ -2292,5 +2309,5 @@
 	case 2: // merges
 		{
-            int lSize = mViewCellsTree->GetSize(vc);
+            int lSize = mViewCellsTree->GetNumInitialViewCells(vc);
 			importance = (float)lSize / (float)mCurrentViewCellsStats.maxLeaves;
 		}
@@ -3218,5 +3235,5 @@
 	case 2: // merged leaves
 		{
-        	int lSize = mViewCellsTree->GetSize(vc);
+        	int lSize = mViewCellsTree->GetNumInitialViewCells(vc);
 			importance = (float)lSize /
 				(float)mCurrentViewCellsStats.maxLeaves;
@@ -4146,5 +4163,5 @@
 	case 2: // merges
 		{
-            int lSize = mViewCellsTree->GetSize(vc);
+            int lSize = mViewCellsTree->GetNumInitialViewCells(vc);
 			importance = (float)lSize / (float)mCurrentViewCellsStats.maxLeaves;
 		}
Index: /GTP/trunk/Lib/Vis/Preprocessing/data/artificial/cube_test.x3d
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/data/artificial/cube_test.x3d	(revision 736)
+++ /GTP/trunk/Lib/Vis/Preprocessing/data/artificial/cube_test.x3d	(revision 736)
@@ -0,0 +1,476 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<X3D profile="Full">
+  <head>
+    <meta name="generator" content="Vrml97ToX3dNist, http://ovrt.nist.gov/v2_x3d.html"/>
+  </head>
+  <Scene>
+  <WorldInfo  info='"VRML2.0 created with Version 1.3, from Alias Maya 7.0"' title="cube_test"/>
+  <NavigationInfo  headlight="true" type='"EXAMINE" "ANY"' speed="1.0"/>
+  <Switch  whichChoice="-1">
+      <Shape >
+          <Appearance >
+              <Material  DEF="lambert1_0"  transparency="0.0" emissiveColor="0.0 0.0 0.0" shininess="0.0" diffuseColor="0.4 0.4 0.4" specularColor="0.0 0.0 0.0"/>
+          </Appearance>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube1_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 4 5 7 6 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube1GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube2_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube2GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube3_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube3GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube4_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube4GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube5_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube5GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube6_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube6GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube7_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube7GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube8_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube8GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube9_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube9GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube10_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube10GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube11_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube11GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube12_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube12GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube13_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube13GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube14_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube14GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube15_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube15GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube16_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube16GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube17_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube17GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube18_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 4 5 7 6 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube18GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube19_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube19GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube20_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube20GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube21_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube21GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube22_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube22GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube23_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube23GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube24_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube24GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube25_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube25GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube26_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube26GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube27_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube27GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube28_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube28GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube29_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube29GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube30_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube30GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube31_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube31GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube32_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube32GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube33_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube33GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube34_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube34GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+      <Shape >
+          <IndexedFaceSet  DEF="pCube35_0Geo"  convex="false" coordIndex=" 0 1 3 2 -1 2 3 5 4 -1 4 5 7 6 -1 6 7 1 0 -1 1 7 5 3 -1 6 0 2 4 -1" solid="false">
+              <Coordinate  DEF="pCube35GeoPoints"  point="-0.5 -0.5 0.5, 0.5 -0.5 0.5, -0.5 0.5 0.5, 0.5 0.5 0.5, -0.5 0.5 -0.5, 0.5 0.5 -0.5, -0.5 -0.5 -0.5, 0.5 -0.5 -0.5, "/>
+          </IndexedFaceSet>
+      </Shape>
+  </Switch>
+  <Group >
+      <Viewpoint  DEF="persp"  position="-15.986234 37.79933 1.84967" orientation="0.526311 0.709299 0.468926  4.486309" description="persp" fieldOfView="0.950022"/>
+      <Transform  DEF="pCube1"  translation="6.655558 0.45904 7.934948" scale="7.817866 2.459988 7.861425" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube1_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube2"  translation="3.830574 0.346653 10.626452" scale="1.0 0.588889 1.0" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 1.0 0.0  0.415444">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube2_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube3"  translation="5.498161 0.472782 7.073905" scale="1.0 0.588889 1.0" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube3_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube4"  translation="8.429504 0.346653 10.626452" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube4_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube5"  translation="6.878703 0.346653 5.867095" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube5_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube6"  translation="8.001698 0.346653 8.273512" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 1.0 0.0  0.69248">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube6_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube7"  translation="5.274425 0.346653 8.273512" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.508899">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube7_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube8"  translation="9.178167 0.346653 5.867095" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube8_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube9"  translation="3.777098 0.346653 5.867095" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube9_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube10"  translation="6.611323 0.346653 9.556934" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube10_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube11"  translation="3.723622 0.346653 7.310945" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.304908">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube11_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube12"  translation="9.552499 0.346653 7.310945" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.304908">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube12_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube13"  translation="9.552499 0.346653 9.129127" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.304908">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube13_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube14"  translation="5.648756 0.346653 10.733405" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.304908">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube14_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube15"  translation="3.777098 0.346653 8.861747" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.304908">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube15_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube16"  translation="4.739665 0.346653 4.797576" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.304908">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube16_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube17"  translation="8.055173 0.346653 6.72271" scale="0.639195 0.445506 0.639195" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.304908">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube17_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube18"  translation="-11.79364 0.45904 -9.391254" scale="7.817865 2.459988 7.861425" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 1.0 0.0  0.750303">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube18_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube19"  translation="-9.902908 0.472782 -10.275702" scale="1.0 0.588889 1.0" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 1.0 0.0  0.38268">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube19_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube20"  translation="-13.860127 0.472782 -7.762333" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube20_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube21"  translation="-9.902908 0.472782 -7.762333" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube21_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube22"  translation="-12.041945 0.472782 -6.051103" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube22_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube23"  translation="-12.041945 0.472782 -10.329178" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube23_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube24"  translation="-12.041945 0.472782 -8.510997" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 1.0 0.0  0.257564">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube24_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube25"  translation="-11.667614 0.472782 -7.28105" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube25_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube26"  translation="-14.341411 0.472782 -9.61125" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube26_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube27"  translation="-13.753176 0.472782 -11.452173" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube27_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube28"  translation="-12.844085 0.472782 -9.313135" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube28_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube29"  translation="-8.29863 0.472782 -9.099232" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 1.0 0.0  0.257564">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube29_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube30"  translation="-10.758523 0.472782 -8.99228" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube30_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube31"  translation="-11.667614 0.472782 -13.487947" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube31_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube32"  translation="-10.797061 0.472782 -12.060557" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube32_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube33"  translation="-12.005784 0.472782 -12.060557" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube33_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube34"  translation="-15.593814 0.472782 -8.984416" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 -1.0 0.0  0.728484">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube34_0Geo"/>
+          </Shape>
+      </Transform>
+      <Transform  DEF="pCube35"  translation="-13.057988 0.472782 -6.585863" scale="0.650923 0.383321 0.650923" scaleOrientation="0.0 0.0 1.0  0.0" rotation="0.0 0.0 0.0  0.0">
+          <Shape >
+              <Appearance >
+                  <Material  USE="lambert1_0"/>
+              </Appearance>
+              <IndexedFaceSet  USE="pCube35_0Geo"/>
+          </Shape>
+      </Transform>
+  </Group>
+  </Scene>
+
+</X3D>
Index: /GTP/trunk/Lib/Vis/shared/EvalStats/EvalStats.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/shared/EvalStats/EvalStats.cpp	(revision 733)
+++ /GTP/trunk/Lib/Vis/shared/EvalStats/EvalStats.cpp	(revision 736)
@@ -110,8 +110,9 @@
 }
 
+
 void EvalNumViewCells(ofstream &outstream,
 					  const StatsContainer &firstStats, 
-					  const StatsContainer &currentStats,
-					  vector<float> &ratios)
+					  const StatsContainer &currentStats)
+		//			  vector<float> &ratios)
 {
 	//const int n = min((int)firstStats.size(), (int)currentStats.size());
@@ -126,5 +127,5 @@
 	// compare render cost of current view cell with render cost 
 	// of other view cells.
-	for (it = currentStats.begin(); it != it_end; ++ it)
+	for (it = currentStats.begin(); it != it_end; ++ it, ++ i)
 	{
 		int j = 0;
@@ -141,7 +142,11 @@
 		float ratio = (float)i / (float)j;
 
-		outstream << "#RenderCost " << renderCost << endl;
-		outstream << "#ViewCellsRatio " << ratio << endl;
-
+		outstream << "#Pass\n" << i << endl;
+		outstream << "#RenderCost\n" << renderCost << endl;
+		outstream << "#ViewCellsRatio\n" << ratio << endl << endl;	
+
+		//cout << "#Pass " << i ++ << endl;
+		//cout << "#RenderCost " << renderCost << endl;
+		//cout << "#ViewCellsRatio " << ratio << endl;	
 	}
 }
@@ -159,4 +164,5 @@
 
 	vector<string> outFilenames;
+	vector<string> outFilenames2;
 
 	// read input files from command line
@@ -182,6 +188,9 @@
 			//sscanf(argv[i], "%s.log", fn);
 			string outFilename = string(fn) + string("-ratio.log");
+			string outFilename2 = string(fn) + string("-reverse.log");
 
 			outFilenames.push_back(outFilename);
+			outFilenames2.push_back(outFilename2);
+			cout << "new filen: " << outFilename2 << endl;
 		}
 		else
@@ -193,8 +202,11 @@
 	//statsOut << "rc1 size: " << (int)renderCosts1.size() << " " << (int)renderCosts2.size() << endl << endl;
 	vector<StatsContainer>::const_iterator it = renderStats.begin(), it_end = renderStats.end();
+
 	vector<string>::const_iterator sit, sit_end = outFilenames.end();
+	vector<string>::const_iterator sit2, sit2_end = outFilenames2.end();
 
 	sit = outFilenames.begin();
-	
+	sit2 = outFilenames2.begin();
+
 	// compare all values with this vector
 	StatsContainer &firstStats = renderStats[0];
@@ -204,10 +216,13 @@
 	//++ sit;
 
-	for (it; it != it_end; ++ it)
+	for (it; it != it_end; ++ it, ++ sit, ++ sit2)
 	{
 		cout << "now writing output to file " << *sit << endl;
 		ofstream statsOut;
 		statsOut.open((*sit).c_str());
-
+		ofstream statsOut2;
+		statsOut2.open((*sit2).c_str());
+
+		cout << "opening new file: " << (*sit2).c_str() << endl;
 		// compute size of output vector
 		const int n = min((int)firstStats.size(), (int)(*it).size());
@@ -221,7 +236,8 @@
 		cout << "need " << vc << " view cells to reach rendercost of method " << i << " with " << n << " view cells" << endl;
 #endif
+		EvalNumViewCells(statsOut2, firstStats, (*it));
+
 		statsOut.close();
-		
-		++ sit;
+		statsOut2.close();
 	}
 
